;;; -*- mode: lisp; syntax: common-lisp; package: common-music; base: 10 -*-

(require :foreign)

(in-package :cm)

(defconstant +midi-read-hook-index+ 0)

(ff:defun-c-callable %midi-read-hook ((event :fixnum) (time :fixnum))
  (declare (special *midi-read-hook*) 
           (optimize (speed 3) (safety 0)))
  (when *midi-read-hook*
      (funcall (the function *midi-read-hook*)
               (the fixnum event) (the fixnum time))))
	    
(ff:register-function '%midi-read-hook +midi-read-hook-index+)

(ff:defforeign '%%midi-open :entry-point "_midiopen" :prototype t
               :arg-checking nil :arguments '(fixnum) :return-type :fixnum)
(ff:defforeign '%midi-close :entry-point "_midiclose"
               :arg-checking nil :arguments '() :return-type :fixnum)
(ff:defforeign '%midi-start-time :entry-point "_midistarttimer"
               :arg-checking nil :arguments '() :return-type :fixnum)
(ff:defforeign '%midi-stop-time :entry-point "_midistoptimer"
               :arg-checking nil :arguments '() :return-type :fixnum)
(ff:defforeign '%midi-get-time :entry-point "_midigettime1"
               :arg-checking nil :arguments '() :return-type :fixnum)
;(ff:defforeign '%midi-get-time :entry-point "_midigettime"
;               :arg-checking nil :prototype t :arguments '(array)
;               :return-type :fixnum)
(ff:defforeign '%midi-set-time :entry-point "_midisettime"
               :arg-checking nil :prototype t :arguments '(fixnum)
               :return-type :fixnum)
(ff:defforeign '%midi-read-messages :entry-point "_midireadmessages"
               :arg-checking nil :arguments '() :return-type :fixnum)
(ff:defforeign '%midi-write-message :entry-point "_midiwritemessage"
               :arg-checking nil :prototype t :arguments '(fixnum fixnum)
               :return-type :fixnum)
(ff:defforeign '%midi-flush-transmit :entry-point "_midiflushxmit"
               :arg-checking nil :arguments '() :return-type :fixnum)
(ff:defforeign '%midi-flush-receive :entry-point "_midiflushrecv"
               :arg-checking nil :arguments '() :return-type :fixnum)
(ff:defforeign '%midi-hush :entry-point "_midihush"
               :arg-checking nil :arguments '() :return-type :fixnum)	       
(ff:defforeign '%midi-all-notes-off :entry-point "_midiallnotesoff" 
               :prototype t :arg-checking nil :arguments '(fixnum)
               :return-type :fixnum)
